/**
 * @file
 * Required functions to configure Pirobox Limit settings in entity types.
 */

(function ($) {
  Drupal.behaviors.formatterPiroboxLimit = {
    attach: function(context, settings) {
      // Realize multiple states if changed Gallery grouping
      // to 'No gallery' and handle the settings
      //   - Gallery image random
      //   - Gallery limitation
      //   - Gallery limitation bypass
      // @see file pirobox_limit.module|pirobox_limit_pirobox_field_formatter_settings_form_get_element_alter()
      $('.pirobox-gallery-grouping').change(function() {
        if ($('.pirobox-gallery-grouping option:selected').val() == 'none') {
          // Handle gallery limitation.
          $('.pirobox-gallery-limit').parent().hide();
          $('.pirobox-gallery-limit').val('0');
          // Handle gallery limitation bypass.
          $('.pirobox-gallery-limit-bypass').parent().hide();
          $('.pirobox-gallery-limit-bypass').val('0');
        }
        if ($('.pirobox-gallery-grouping option:selected').val() != 'none') {
          // Handle gallery limitation.
          $('.pirobox-gallery-limit').parent().show();
          // Handle gallery limitation bypass.
          $('.pirobox-gallery-limit-bypass').parent().show();
        }
      });
      // Realize multiple states if changed Gallery limitation
      // to 'Do not use' and handle the settings
      //   - Gallery limitation bypass
      // @see file pirobox_limit.module|pirobox_limit_pirobox_field_formatter_settings_form_get_element_alter()
      //
      // Check and handle image random and check gallery limitation.
      // Gallery limitation and Gallery image random
      // at the same time is not possible.
      $('.pirobox-gallery-limit').change(function() {
        if ($('.pirobox-gallery-limit option:selected').val() == 0) {
          // Handle gallery limitation bypass.
          $('.pirobox-gallery-limit-bypass').parent().hide();
          $('.pirobox-gallery-limit-bypass').val('0');

          // Handle image random.
          $('#pirobox-limit-random-warning').hide();
          // Enable form buttons.
          $('input[type=submit]').removeAttr('disabled');
        }
        if ($('.pirobox-gallery-limit option:selected').val() != 0) {
          // Handle gallery limitation bypass.
          $('.pirobox-gallery-limit-bypass').parent().show();

          // Check and handle image random.
          if ($('.pirobox-gallery-random').attr('checked') == true) {
            $('#pirobox-limit-random-warning').show();
            // Disable form buttons.
            $('input[type=submit]').attr('disabled', 'disabled');
          }
          else {
            $('#pirobox-limit-random-warning').hide();
            // Enable form buttons.
            $('input[type=submit]').removeAttr('disabled');
          }
        }
      });
      // Check and handle image random and check gallery limitation.
      // Gallery limitation and Gallery image random
      // at the same time is not possible.
      $('.pirobox-gallery-random').change(function() {
        if ($('.pirobox-gallery-limit option:selected').val() != 0 && $('.pirobox-gallery-random').attr('checked') == true) {
          $('#pirobox-limit-random-warning').show();
          // Disable form buttons.
          $('input[type=submit]').attr('disabled', 'disabled');
        }
        if ($('.pirobox-gallery-limit option:selected').val() == 0 || $('.pirobox-gallery-random').attr('checked') == false) {
          $('#pirobox-limit-random-warning').hide();
          // Enable form buttons.
          $('input[type=submit]').removeAttr('disabled');
        }
      });
    }
  };
})(jQuery);
